#include <stdio.h>
#include <stdlib.h>

#include "socket.h"

unsigned call_tcp_stack(unsigned function);
#pragma aux call_tcp_stack = \
  "int 0x61" \
  parm [ax] value [ax];

int main()
{
  unsigned long l;
  int s;
  struct sockaddr_in sockaddr;
  unsigned n = sizeof(sockaddr);
  int r;

  s = socket(AF_INET, SOCK_DGRAM, 0);
  if(s != -1)
  {
    r = getsockname(s, &sockaddr, &n);
    close_socket(s);
    if(r == -1)
      puts("Could not get my IP address!");
    printf("IP address: ");
    printf("%u.", ((unsigned char*)&sockaddr.sin_addr.s_addr)[0]);
    printf("%u.", ((unsigned char*)&sockaddr.sin_addr.s_addr)[1]);
    printf("%u.", ((unsigned char*)&sockaddr.sin_addr.s_addr)[2]);
    printf("%u\n", ((unsigned char*)&sockaddr.sin_addr.s_addr)[3]);
  }
  else puts("Not enough resources to create new socket");

  printf("active sockets: %u\n", call_tcp_stack(13));
  printf("rx errors: %u\n", call_tcp_stack(14));
  printf("tx errors: %u\n", call_tcp_stack(15));
  printf("dropped rx packets: %u\n", call_tcp_stack(16));
  printf("dropped tx packets: %u\n", call_tcp_stack(17));
  printf("rx packets: %u\n", call_tcp_stack(18));
  printf("tx packets: %u\n", call_tcp_stack(19));

  l = call_tcp_stack(20) | ((unsigned long)call_tcp_stack(21) << 16);
  printf("rx bytes: %lu\n", l);
  l = call_tcp_stack(22) | ((unsigned long)call_tcp_stack(23) << 16);
  printf("tx bytes: %lu\n", l);

  return 0;
}
